/*==============================================================================
 This is the golden measure for the DEATHSTAR encryption project
 Designed by Lynn Asiimwe, Daniel Galasko and Victor Mushabe of 15A
 for the University of Cape Town
 ==============================================================================*/
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <math.h>
#include <fstream>

using namespace std;
/*==============================================================================
 ENCRYPTION FUNCTION
 ==============================================================================*/
void encrypt(string original)
{
    string encrypted = "";
    string key="bluelabs";
    
    int x=0;
    
  	for (int temp = 0; temp < original.size(); temp++)
   	{
        if(x==7)
   		{
   			x=0;
   		}
       	encrypted += original[temp] ^ (int(key[x]) + temp) % 255;
       	x++;
   	}
    
    
    
}
/*==============================================================================
 DECRYPTION FUNCTION
 ==============================================================================*/

void decrypt(string enfile)
{
	string unencrypt;
	string key="bluelabs";
	int x=0;
   	for (int temp = 0; temp < enfile.size(); temp++)
   	{
   	 	if(x==7)
   		{
   			x=0;
   		}
    	unencrypt += enfile[temp] ^ (int(key[x]) + temp) % 255;
      	x++;
   	}
}

/*==============================================================================
 MAIN CODE
 ==============================================================================*/
int main()
{
    char x;
    string line;
    struct timeval start_time, end_time;
    double run_time, total_time;
    ifstream myfile ("text.file");
    if (myfile.is_open())
    {
        while ( myfile.good() )
        {
            getline (myfile,line);
            if(line!="")
            {
                gettimeofday(&start_time, NULL);
                
                /* Step 4: Call a user function! */
                encrypt(line);
                
                /* Step 5: Check & print elapsed time */
                gettimeofday(&end_time, NULL);
                run_time = ((double)(end_time.tv_sec) + (double)(end_time.tv_usec)/1000000.0)
                - ((double)(start_time.tv_sec) + (double)(start_time.tv_usec)/1000000.0);
                total_time+=run_time;
                //cout << run_time << " RUN TIME";
                
            }
        }
        myfile.close();
    }
    
    cout << total_time << " RUN TIME \n";
    
}
//==============================================================================