----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:19:57 05/16/2012 
-- Design Name: 
-- Module Name:    memory_out - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity memory_out is
    Port ( header : in  STD_LOGIC_VECTOR (7 downto 0);
           data1 : in  STD_LOGIC_VECTOR (7 downto 0);
           data2 : in  STD_LOGIC_VECTOR (7 downto 0);
           data3 : in  STD_LOGIC_VECTOR (7 downto 0);
           data4 : in  STD_LOGIC_VECTOR (7 downto 0);
           clk : in  STD_LOGIC;
           address : in  STD_LOGIC_VECTOR (2 downto 0);
           data_out : out  STD_LOGIC_VECTOR (7 downto 0));
end memory_out;

architecture Behavioral of memory_out is
signal header_mem: std_logic_vector(7 downto 0);
signal data1_mem: std_logic_vector(7 downto 0);
signal data2_mem: std_logic_vector(7 downto 0);
signal data3_mem: std_logic_vector(7 downto 0);
signal data4_mem: std_logic_vector(7 downto 0);
begin

process(clk,address)
begin
header_mem<=header;
data1_mem<=data1;
data2_mem<=data2;
data3_mem<=data3;
data4_mem<=data4;
	if(clk='1' and clk'EVENT)then
			case address is
				when "000" => data_out<=header_mem;
				when "001" => data_out<=data1_mem;
				when "010" => data_out<=data2_mem;
				when "011" => data_out<=data3_mem;
				when "100" => data_out<=data4_mem;
				when others => null;
			end case;
	end if;
end process;


end Behavioral;

